//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
#include "Unit1.h"
#include <A3nalogGauge.hpp>
#include "unt_An4logGauge.h"
#include <cstdlib.h> // std::random
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"

#define K_VALUE (10)

    TfrmMainDemo* frmMainDemo;
    // Ehmm, avoiding RAD
    TA3nalogGauge *A3n[2]; // Irnis Haliullin's analog gauges
    cls_An4logGauge *m_try, *mf; // Try properties meter, focused meter
    cls_An4logGauge *mc[2]; // Comparison meters
    cls_An4logGauge *me1[2]; // Examples meters 1
    cls_An4logGauge *me2[3]; // Examples meters 2


//---------------------------------------------------------------------------
__fastcall TfrmMainDemo::TfrmMainDemo(TComponent* Owner) : TForm(Owner)
{
// . . . Contained objects
    tabFeatures->DoubleBuffered = true;
    Disable_trkValueChange = false;

// . . . Feature tab
    m_try = new cls_An4logGauge(pnlContainer);
    m_try->Align = alClient;
    m_try->BevelOuter = bvRaised;
    m_try->BevelInner = bvLowered;
    m_try->HubRadius = 10;
    m_try->OnMouseDown = MeterMouseDown;
    m_try->OnFPSMeasure = Measure_An4log;
    m_try->OnChangingBand = MeterChangeBand;
    m_try->OnExceeding = MeterExceeding;
    mf = m_try;

    Caption = String(m_try->ClassName()) + String(" ver.") + String(AN4_VERSION) + String(" demo");

// . . . Compare tab
    // Old one
    A3n[0] = new TA3nalogGauge(tabCompare);
    A3n[0]->Parent = tabCompare;
    A3n[0]->Top = lblTabCompare->Top + lblTabCompare->Height + 5;
    A3n[0]->Left = 5;
    A3n[0]->Width = tabCompare->Width/2;
    A3n[0]->Height = tabCompare->Height/3;
    //A3n[0]->Margin = 5;
    A3n[0]->Style = CenterStyle; //(LeftStyle, RightStyle, CenterStyle);
    A3n[0]->FaceOptions = A3n[0]->FaceOptions >> ShowMargin << ShowFrame << Show3D << ShowIndicatorMin << ShowIndicatorMid << ShowIndicatorMax << ShowValues; //(ShowMargin, ShowCircles, ShowMainTicks, ShowSubTicks,ShowIndicatorMin, ShowIndicatorMid, ShowIndicatorMax,ShowValues, ShowCenter, ShowFrame, Show3D, ShowCaption);
    A3n[0]->AntiAliased = aaNone; //(aaNone, aaBiline, aaTriline, aaQuadral);
    A3n[0]->Scale = 100;
    A3n[0]->Angle = 150;
    A3n[0]->NumberMainTicks = 10;
    A3n[0]->Position = 0;
    A3n[0]->OnFrames = Measure_A3nalog;
    lblFPS_A3nalog->Left = A3n[0]->Left + A3n[0]->Width + 10;
    lblFPS_A3nalog->Top = A3n[0]->Top + A3n[0]->Height/2;

    // New one
    mc[0] = new cls_An4logGauge(tabCompare);
    mc[0]->Top = A3n[0]->Top + A3n[0]->Height + 20;
    mc[0]->Left = A3n[0]->Left;
    mc[0]->Width = A3n[0]->Width;
    mc[0]->Height = A3n[0]->Height;
    mc[0]->BevelOuter = bvRaised;
    mc[0]->BevelInner = bvLowered;
    mc[0]->Options = mc[0]->Options >> cls_An4logGauge::opShowMinMax;
    mc[0]->FullScaleMax = 100;
    mc[0]->SetCenteredLayout(150);
    mc[0]->NumMainTicks = 10;
    mc[0]->Value = 0;
    mc[0]->HighBand = 80;
    mc[0]->LowBand = 20;
    mc[0]->OnMouseDown = MeterMouseDown;
    mc[0]->OnFPSMeasure = Measure_An4log;
    lblFPS_An4log->Left = mc[0]->Left + mc[0]->Width + 10;
    lblFPS_An4log->Top = mc[0]->Top + mc[0]->Height/2;

    A3n[1] = 0;
    /*
    A3n[1] = new TA3nalogGauge(tabCompare);
    A3n[1]->Parent = tabCompare;
    A3n[1]->Top = A3n[0]->Top;
    A3n[1]->Left = A3n[0]->Left + A3n[0]->Width + 20;
    A3n[1]->Width = 200;
    A3n[1]->Height = 200;
    A3n[1]->Margin = 5;
    //A3n[1]->LengthMainTicks
    A3n[1]->Style = CenterStyle; //(LeftStyle, RightStyle, CenterStyle);
    A3n[1]->FaceOptions = A3n[1]->FaceOptions >> ShowMargin << ShowFrame << Show3D << ShowIndicatorMin << ShowIndicatorMid << ShowIndicatorMax << ShowValues; //(ShowMargin, ShowCircles, ShowMainTicks, ShowSubTicks,ShowIndicatorMin, ShowIndicatorMid, ShowIndicatorMax,ShowValues, ShowCenter, ShowFrame, Show3D, ShowCaption);
    A3n[1]->AntiAliased = aaNone; //(aaNone, aaBiline, aaTriline, aaQuadral);
    A3n[1]->Scale = 360;
    A3n[1]->Angle = 359;
    A3n[1]->IndMaximum = 0;
    A3n[1]->IndMinimum = 0;
    A3n[1]->NumberMainTicks = 12;
    A3n[1]->Position = 0;
    */

    mc[1] = 0;
    /*
    mc[1] = new cls_An4logGauge(tabCompare);
    mc[1]->Top = mc[0]->Top;
    mc[1]->Left = A3n[1]->Left;
    mc[1]->Width = 200;
    mc[1]->Height = 150;
    mc[1]->Padding = 5;
    mc[1]->SetCenteredLayout(360);
    mc[1]->AngleMin = 270;
    mc[1]->Options = mc[0]->Options;
    mc[1]->FullScaleMax = 360;
    mc[1]->HighBand = 0;
    mc[1]->LowBand = 0;
    mc[1]->NumMainTicks = 12;
    */
    /*
    me[x]->Width = 250;
    me[x]->Height = 200;
    me[x]->MarginLeft = 20;
    me[x]->MarginTop = 25;
    me[x]->MarginRight = 20;
    me[x]->MarginBottom = 50;
    me[x]->BevelOuter = bvRaised;
    me[x]->BevelInner = bvLowered;
    me[x]->DisplayColor = TColor(0xEDE1D9);
    */


// . . . Meters using an external background
    // . . . Voltmeter
    me1[0] = new cls_An4logGauge(tabFixedBackgrounds1);
    me1[0]->BackgroundBmp = imgVoltmeter->Picture->Bitmap;
    me1[0]->Top = lblTabFixedBkg1->Top + lblTabFixedBkg1->Height + 20;
    me1[0]->Left = 5;
    me1[0]->OnMouseDown = MeterMouseDown;
    me1[0]->OnFPSMeasure = Measure_An4log;
    me1[0]->PointerWidth = 1;
    me1[0]->PointerColor = TColor(0x564D41);
    me1[0]->Options = me1[0]->Options >> cls_An4logGauge::opShowMinMax;
    me1[0]->AntiAliased = true;
    me1[0]->EnableDynamic = true;
    me1[0]->ShowHint = true;
    // Ok, now some manual fitting
    me1[0]->FullScaleMax = 500.0;
    me1[0]->FullScaleMin = 100.0;
    // Using 'OnMouseDown' event to see following coordinates, dependent on background bitmap
    me1[0]->ManualTune( TPoint(140,201), // Pointer pivot
                        101,3,           // Pointer length and hub radius
                        TPoint(75,124),TPoint(210,128), // Min and max positions
                        TPoint(217,135)                 // Max exceeding position (over fullscale)
                       );
    // . . . Amperometer
    me1[1] = new cls_An4logGauge(tabFixedBackgrounds1);
    me1[1]->BackgroundBmp = imgAmperometer->Picture->Bitmap;
    me1[1]->Top = me1[0]->Top + me1[0]->Height/2 - me1[1]->Height/2;
    me1[1]->Left = me1[0]->Left + me1[0]->Width + 20;
    me1[1]->OnMouseDown = MeterMouseDown;
    me1[1]->PointerWidth = 1;
    me1[1]->PointerColor = TColor(0x7F67A7);
    me1[1]->Options = me1[1]->Options >> cls_An4logGauge::opShowMinMax;
    me1[1]->AntiAliased = me1[0]->AntiAliased;
    me1[1]->EnableDynamic = me1[0]->EnableDynamic;
    me1[1]->ShowHint = me1[0]->ShowHint;
    // Ok, now some manual fitting
    me1[1]->FullScaleMax = 5.0;
    me1[1]->FullScaleMin = 0.0;
    me1[1]->ManualTune( TPoint(75,109), // Pointer pivot
                        80,25,          // Pointer length and hub radius
                        TPoint(18,53),TPoint(133,55), // Min and max positions
                        TPoint(134,59)                // Max exceeding position (over fullscale)
                       );

    // . . . Manometer med
    me2[0] = new cls_An4logGauge(tabFixedBackgrounds2);
    me2[0]->BackgroundBmp = imgManometer2->Picture->Bitmap;
    me2[0]->Top = lblTabFixedBkg2->Top + lblTabFixedBkg2->Height + 20;
    me2[0]->Left = 5;
    me2[0]->OnMouseDown = MeterMouseDown;
    me2[0]->PointerWidth = 1;
    me2[0]->PointerColor = TColor(0x57778A);
    me2[0]->Options = me2[0]->Options >> cls_An4logGauge::opShowMinMax;
    me2[0]->AntiAliased = me1[0]->AntiAliased;
    me2[0]->EnableDynamic = me1[0]->EnableDynamic;
    me2[0]->ShowHint = me1[0]->ShowHint;
    // Ok, now some manual fitting
    me2[0]->FullScaleMax = 300.0;
    me2[0]->FullScaleMin = 0.0;
    me2[0]->ManualTune( TPoint(128,131), // Pointer pivot
                        100,0,          // Pointer length and hub radius
                        TPoint(62,194),TPoint(194,196), // Min and max positions
                        TPoint(66,197)                // Max exceeding position (over fullscale)
                       );
        // . . . Manometer big
    me2[1] = new cls_An4logGauge(tabFixedBackgrounds2);
    me2[1]->BackgroundBmp = imgManometer1->Picture->Bitmap;
    me2[1]->Top = me2[0]->Top;
    me2[1]->Left = tabFixedBackgrounds2->Left + tabFixedBackgrounds2->Width - me2[1]->Width - 20;
    me2[1]->OnMouseDown = MeterMouseDown;
    me2[1]->PointerWidth = 3;
    me2[1]->PointerColor = TColor(0x514D4D);
    me2[1]->Options = me2[1]->Options >> cls_An4logGauge::opShowMinMax;
    me2[1]->AntiAliased = me2[0]->AntiAliased;
    me2[1]->EnableDynamic = me2[0]->EnableDynamic;
    me2[1]->ShowHint = me2[0]->ShowHint;
    // Ok, now some manual fitting
    me2[1]->FullScaleMax = 10.0;
    me2[1]->FullScaleMin = 1.5;
    me2[1]->ManualTune( TPoint(123,125), // Pointer pivot
                       82,-20,           // Pointer length and hub radius
                       TPoint(69,180),TPoint(181,183), // Min and max positions
                       TPoint(173,186)                 // Max exceeding position (over fullscale)
                      );
    // . . . Manometer small
    me2[2] = new cls_An4logGauge(tabFixedBackgrounds2);
    me2[2]->BackgroundBmp = imgManometer3->Picture->Bitmap;
    me2[2]->Top = me2[0]->Top + me2[0]->Height - me2[2]->Height/2;
    me2[2]->Left = me2[0]->Left + me2[0]->Width;
    me2[2]->OnMouseDown = MeterMouseDown;
    me2[2]->OnChangingBand = AnotherChangeBand;
    me2[2]->PointerWidth = 2;
    me2[2]->PointerColor = TColor(0x3D3932);
    me2[2]->Options = me2[2]->Options >> cls_An4logGauge::opShowMinMax;
    me2[2]->AntiAliased = me2[0]->AntiAliased;
    me2[2]->EnableDynamic = me2[0]->EnableDynamic;
    me2[2]->ShowHint = me2[0]->ShowHint;
    // Ok, now some manual fitting
    me2[2]->FullScaleMax = 30.0;
    me2[2]->FullScaleMin = 0.0;
    me2[2]->HighBand = 15.0;
    me2[2]->LowBand = me2[2]->FullScaleMin;
    me2[2]->ManualTune( TPoint(79,77), // Pointer pivot
                        58,-10,           // Pointer length and hub radius
                        TPoint(34,117),TPoint(120,117), // Min and max positions
                        TPoint(117,119)                 // Max exceeding position (over fullscale)
                       );
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::InitInterface(cls_An4logGauge* m)
{ // Init interface
    #define GET_OPT(x) chlOptions->Checked[cls_An4logGauge::x]=m->Options.Contains(cls_An4logGauge::x);

    edtValue->Text = String(m->Value);
    trkValue->Position = m->Value * K_VALUE;
    edtCaption->Text = m->Caption;

    edtFullScaleMax->Text = String(m->FullScaleMax);
    edtFullScaleMin->Text = String(m->FullScaleMin);
    
    edtHighBand->Text = String(m->HighBand);
    edtLowBand->Text = String(m->LowBand);
    speBandThickness->Value = mf->BandThickness;

    trkAngleMin->Position = m->AngleMin;
    lblAngleMin->Caption = "AngleMin: " + String(m->AngleMin) + "";
    trkAngleRange->Position = m->AngleRange;
    lblAngleRange->Caption = "AngleRange: " + String(m->AngleRange) + "";
    speAngleExceed->Value = mf->AngleExceed;

    speMarginLeft->Value = mf->MarginLeft;
    speMarginTop->Value = mf->MarginTop;
    speMarginRight->Value = mf->MarginRight;
    speMarginBottom->Value = mf->MarginBottom;
    spePadding->Value = m->Padding;

    spePointerWidth->Value = m->PointerWidth;
    speHubRadius->Value = m->HubRadius;

    GET_OPT(opShowMainTicks)
    GET_OPT(opShowSubTicks)
    GET_OPT(opShowTickNumbers)
    GET_OPT(opShowMinBand)
    GET_OPT(opShowMidBand)
    GET_OPT(opShowHighBand)
    GET_OPT(opShowMinMax)
    GET_OPT(opShowHub)
    GET_OPT(opShowCaption)

    chkAntialiased->Checked = m_try->AntiAliased;

    chkEnableDynamic->Checked = m->EnableDynamic; chkEnableDynamicClick(chkEnableDynamic);
    edtkT->Text = String(m->kT);
    edtkF->Text = String(m->kF);

    speNumMainTicks->Value = mf->NumMainTicks;
    speNumSubTicks->Value = mf->NumSubTicks;
    speLengthMainTicks->Value = mf->LengthMainTicks;
    speLengthSubTicks->Value = mf->LengthSubTicks;

    cbxBevelInner->ItemIndex = mf->BevelInner;
    cbxBevelOuter->ItemIndex = mf->BevelOuter;

    // Shape colors
    shpBodyColor->Brush->Color = mf->BodyColor;
    shpBorderColor->Brush->Color = mf->BorderColor; 
    shpDisplayColor->Brush->Color = mf->DisplayColor;
    shpTicksColor->Brush->Color = mf->TicksColor;  
    shpValueColor->Brush->Color = mf->TicksFont->Color;
    shpCaptionColor->Brush->Color = mf->Font->Color;
    shpPointerColor->Brush->Color = mf->PointerColor;
    shpHubColor->Brush->Color = mf->HubColor; 
    shpLowBandColor->Brush->Color = mf->LowBandColor;
    shpMidBandColor->Brush->Color = mf->MidBandColor;
    shpHighBandColor->Brush->Color = mf->HighBandColor;
}

//================================ Handlers =================================

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::MeterMouseDown(TObject* Sender, TMouseButton Button, Classes::TShiftState Shift, int X, int Y)
{
    cls_An4logGauge* sender = dynamic_cast<cls_An4logGauge*>(Sender);
    // Reset max and min values at double click
    if ( Shift.Contains(ssDouble) ) sender->Reset();

    if ( sender == m_try )
         {
          sender->Value = sender->ClickedValue;
          Disable_trkValueChange = true;
          edtValue->Text = String(sender->Value);
          trkValue->Position = sender->Value * K_VALUE;
          Disable_trkValueChange = false;
          lblClickedAngle->Caption = String("ClickedAngle: ") + String(sender->ClickedAngle);
          lblClickedValue->Caption = String("ClickedValue: ") + FloatToStrF(sender->ClickedValue,ffGeneral,6,3);
         }
    else if ( sender == me1[0] || sender == me1[1] || sender == me2[0] || sender == me2[1] || sender == me2[2] )
         {
          sender->Tap();
          // sender->Caption = sender->ClickedValue;
          // The following was used to determine arguments of 'ManualTune'
          //::ShowMessage(String("P=(") + String(X) + String(";") + String(Y) + String("), a=") + String(sender->ClickedAngle));
          //::ShowMessage(String(" AngleMin:") + String(sender->AngleMin) + String(" AngleRange:") + String(sender->AngleRange) + String(" AngleExceed:") + String(sender->AngleExceed));
         }
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::MeterChangeBand(TObject* Sender)
{
    cls_An4logGauge* sender = dynamic_cast<cls_An4logGauge*>(Sender);

    TColor SignalColor;
    switch ( sender->CurrentBand )
           {
            case cls_An4logGauge::bnMid  : SignalColor = sender->MidBandColor; break;
            case cls_An4logGauge::bnLow  : SignalColor = sender->LowBandColor; break;
            case cls_An4logGauge::bnHigh : SignalColor = sender->HighBandColor; break;
            default                      : SignalColor = sender->BodyColor;
           }
    // Signal
    //sender->ValueColor = SignalColor;
    //sender->CaptionColor = SignalColor;
    //sender->PointerColor = SignalColor;
    sender->HubColor = SignalColor;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::AnotherChangeBand(TObject* Sender)
{
    cls_An4logGauge* sender = dynamic_cast<cls_An4logGauge*>(Sender);
    if ( sender &&  sender->CurrentBand==cls_An4logGauge::bnHigh )
         {
          lblSignal->Caption = "Too much!!";
         }
    else {
          lblSignal->Caption = "Ok";
         }
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::MeterExceeding(TObject* Sender)
{
    cls_An4logGauge* sender = dynamic_cast<cls_An4logGauge*>(Sender);

    if ( sender->Value > sender->FullScaleMax ) sender->Caption = "blown up";
    else sender->Caption = edtCaption->Text;
}



//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::Measure_A3nalog(TObject* Sender)
{
    TA3nalogGauge* sender = dynamic_cast<TA3nalogGauge*>(Sender);
    lblFPS_A3nalog->Caption = String("TA3nalogGauge fps: ") + String(sender->Frames);
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::Measure_An4log(TObject* Sender)
{
    cls_An4logGauge* sender = dynamic_cast<cls_An4logGauge*>(Sender);
    if (sender == mc[0]) lblFPS_An4log->Caption = String("cls_An4logGauge fps: ") + String(sender->fps);
    else if (sender == me1[0]) lblFPS_An4log_me->Caption = String("fps: ") + String(sender->fps);
    else if (sender == m_try) lblFPS_mtry->Caption = String("fps: ") + String(sender->fps);
}



//================================= Events ==================================


//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::tabFeaturesShow(TObject *Sender)
{
    InitInterface(m_try);
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::tabFeaturesHide(TObject *Sender)
{
    ;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::trkValueChange(TObject *Sender)
{
    if (Disable_trkValueChange) return;
    mf->Value = double(trkValue->Position)/K_VALUE;
    edtValue->Text = String(mf->Value);
    //m->Caption = ::FloatToStrF(m_try->Value,ffGeneral,3,3);
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::edtValueKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
    if ( Key == VK_RETURN )
       {
        Disable_trkValueChange = true;
        mf->Value = edtValue->Text.Trim().ToDouble();
        trkValue->Position = mf->Value * K_VALUE;
        Disable_trkValueChange = false;
       }
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::edtCaptionChange(TObject *Sender)
{
    mf->Caption = edtCaption->Text;
}

//---------------------------------------------------------------------------

void __fastcall TfrmMainDemo::edtFullScaleMinKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
    if ( Key == VK_RETURN ) mf->FullScaleMin = edtFullScaleMin->Text.Trim().ToDouble();
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::edtFullScaleMaxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
    if ( Key == VK_RETURN ) mf->FullScaleMax = edtFullScaleMax->Text.Trim().ToDouble();
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::edtLowBandExit(TObject *Sender)
{
    mf->LowBand = edtLowBand->Text.Trim().ToDouble();
    mf->HighBand = edtHighBand->Text.Trim().ToDouble();
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::edtLowBandKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
    if ( Key == VK_RETURN ) edtLowBandExit(Sender);
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::speBandThicknessChange(TObject *Sender)
{
    mf->BandThickness = speBandThickness->Value;
    speBandThickness->Value = mf->BandThickness;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::trkAngleMinChange(TObject *Sender)
{
    m_try->AngleMin = trkAngleMin->Position;
    lblAngleMin->Caption = "AngleMin: " + String(m_try->AngleMin) + "";
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::trkAngleRangeChange(TObject *Sender)
{
    m_try->AngleRange = trkAngleRange->Position;
    lblAngleRange->Caption = "AngleRange: " + String(m_try->AngleRange) + "";
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::speAngleExceedChange(TObject *Sender)
{
    mf->AngleExceed = speAngleExceed->Value;
    speAngleExceed->Value = mf->AngleExceed;
}


//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::chlOptionsClickCheck(TObject *Sender)
{
    TCheckListBox* chk = dynamic_cast<TCheckListBox*>(Sender);

    #define APPLY_OPT(x) if(chk->Checked[cls_An4logGauge::x])\
                             {mf->Options=mf->Options<<cls_An4logGauge::x;}\
                         else{mf->Options=mf->Options>>cls_An4logGauge::x;}

    APPLY_OPT(opShowMainTicks)
    APPLY_OPT(opShowSubTicks)
    APPLY_OPT(opShowTickNumbers)
    APPLY_OPT(opShowMinBand)
    APPLY_OPT(opShowMidBand)
    APPLY_OPT(opShowHighBand)
    APPLY_OPT(opShowMinMax)
    APPLY_OPT(opShowHub)
    APPLY_OPT(opShowCaption)

    m_try->Invalidate();
    m_try->Perform(WM_PAINT,0,0);
    Application->ProcessMessages();

    //mc[1]->Options = m_try->Options;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::speMarginLeftChange(TObject *Sender)
{
    mf->MarginLeft = speMarginLeft->Value;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::speMarginTopChange(TObject *Sender)
{
    mf->MarginTop = speMarginTop->Value;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::speMarginRightChange(TObject *Sender)
{
    mf->MarginRight = speMarginRight->Value;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::speMarginBottomChange(TObject *Sender)
{
    mf->MarginBottom = speMarginBottom->Value;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::spePaddingChange(TObject *Sender)
{
    m_try->Padding = spePadding->Value;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::chkAntialiasedClick(TObject *Sender)
{
    m_try->AntiAliased = chkAntialiased->Checked;
}


//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::spePointerWidthChange(TObject *Sender)
{
    mf->PointerWidth = spePointerWidth->Value;
    spePointerWidth->Value = mf->PointerWidth;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::speHubRadiusChange(TObject *Sender)
{
    m_try->HubRadius = speHubRadius->Value;
}


//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::chkEnableDynamicClick(TObject *Sender)
{
    m_try->EnableDynamic = chkEnableDynamic->Checked;
    edtkT->Enabled = chkEnableDynamic->Checked;
    edtkF->Enabled = chkEnableDynamic->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::edtkTExit(TObject *Sender)
{
    try {
         m_try->kT = edtkT->Text.Trim().ToDouble();
         m_try->kF = edtkF->Text.Trim().ToDouble();
        }
    catch (EConvertError&)
       {
        edtkT->Text = String(m_try->kT);
        edtkF->Text = String(m_try->kF);
       }
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::edtkTKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
    if ( Key == VK_RETURN ) edtkTExit(Sender);
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::speNumMainTicksChange(TObject *Sender)
{
    mf->NumMainTicks = speNumMainTicks->Value;
    speNumMainTicks->Value = mf->NumMainTicks;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::speNumSubTicksChange(TObject *Sender)
{
    mf->NumSubTicks = speNumSubTicks->Value;
    speNumSubTicks->Value = mf->NumSubTicks;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::speLengthMainTicksChange(TObject *Sender)
{
    mf->LengthMainTicks = speLengthMainTicks->Value;
    speLengthMainTicks->Value = mf->LengthMainTicks;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::speLengthSubTicksChange(TObject *Sender)
{
    mf->LengthSubTicks = speLengthSubTicks->Value;
    speLengthSubTicks->Value = mf->LengthSubTicks;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::cbxBevelOuterChange(TObject *Sender)
{
    mf->BevelOuter = TBevelCut(cbxBevelOuter->ItemIndex);
    cbxBevelOuter->ItemIndex = mf->BevelOuter;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::cbxBevelInnerChange(TObject *Sender)
{
    mf->BevelInner = TBevelCut(cbxBevelInner->ItemIndex);
    cbxBevelInner->ItemIndex = mf->BevelInner;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::shpBodyColorMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
{ // Modify color

    TShape* shp = dynamic_cast<TShape*>(Sender);
    if ( shp ) {
                TColorDialog *dlgColor = new TColorDialog(this);
                dlgColor->Color = shp->Brush->Color;
                dlgColor->Options = TColorDialogOptions() << cdFullOpen;
                if ( dlgColor->Execute() ) shp->Brush->Color = dlgColor->Color;
                delete dlgColor;
               }
    // Bulk update to avoid separate handlers
    mf->BodyColor = shpBodyColor->Brush->Color;
    mf->BorderColor = shpBorderColor->Brush->Color;
    mf->DisplayColor = shpDisplayColor->Brush->Color;
    mf->TicksColor = shpTicksColor->Brush->Color;
    mf->TicksFont->Color = shpValueColor->Brush->Color;
    mf->Font->Color = shpCaptionColor->Brush->Color;
    mf->PointerColor = shpPointerColor->Brush->Color;
    mf->HubColor = shpHubColor->Brush->Color;
    mf->LowBandColor = shpLowBandColor->Brush->Color;
    mf->MidBandColor = shpMidBandColor->Brush->Color;
    mf->HighBandColor = shpHighBandColor->Brush->Color;
}





//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::tabCompareShow(TObject *Sender)
{
    tmrValues1->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMainDemo::tabCompareHide(TObject *Sender)
{
    tmrValues1->Enabled = false;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::tmrValues1Timer(TObject *Sender)
{
    static double t = 0;
    t += 1E-3 * tmrValues1->Interval;
    double v = std::sin((10*M_PI/tmrValues1->Interval) * t);
    for ( int i=0; i<2; ++i )
        {
         if (A3n[i]) A3n[i]->Position = A3n[i]->Scale/2 * (1 + v);
         if (mc[i]) mc[i]->Value = mc[i]->FullScaleMin + mc[i]->FullScaleMax/2 * (1 + v);
        }
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::rgrTimerClick(TObject *Sender)
{
    switch ( rgrTimer->ItemIndex )
           {
            case 0 :
                tmrValues1->Interval = 300;
                //tmrValues1->Enabled = true;
                break;
            case 1 :
                tmrValues1->Interval = 30;
                //tmrValues1->Enabled = true;
                break;
            default: tmrValues1->Enabled = false;
           }
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::chkAntiAliased_CompareClick(TObject *Sender)
{
    A3n[0]->AntiAliased = chkAntiAliased_Compare->Checked ? aaTriline : aaNone;
    mc[0]->AntiAliased = chkAntiAliased_Compare->Checked;
}



//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::tabFixedBackgrounds1Show(TObject *Sender)
{
    // Interface
    chkAntialiased_me1->Checked = me1[0]->AntiAliased;
    chkEnableDynamic_me1->Checked = me1[0]->EnableDynamic;
    tmrValues2->Enabled = true;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::tabFixedBackgrounds1Hide(TObject *Sender)
{
    tmrValues2->Enabled = false;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::tabFixedBackgrounds2Show(TObject *Sender)
{
    // Interface
    chkAntialiased_me2->Checked = me2[0]->AntiAliased;
    chkEnableDynamic_me2->Checked = me2[0]->EnableDynamic;
    tmrRandom->Enabled = true;
    speTimerInterval_me2->Value = tmrRandom->Interval;
    lblSignal->Top = me2[2]->Top - lblSignal->Height - 5;
    lblSignal->Left = me2[2]->Left + me2[2]->Width/2 - lblSignal->Width/2;
    lblSignal->Caption = "Ok";
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::tabFixedBackgrounds2Hide(TObject *Sender)
{
    tmrRandom->Enabled = false;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::tmrRandomTimer(TObject *Sender)
{
    static bool randomize_done = false;
    if (!randomize_done) { std::randomize(); randomize_done=true; }
    for ( int i=0; i<3; ++i )
        {
         if (me2[i]) me2[i]->Value = me2[i]->FullScaleMin + std::random(me2[i]->ValueRange * 10.0)/10.0;
        }
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::tmrValues2Timer(TObject *Sender)
{
    static double M0 = me1[0]->FullScaleMin + 3*me1[0]->ValueRange/5;
    static double M1 = me1[1]->FullScaleMin + me1[1]->ValueRange/2;
    static double t = 0;
    t += 1E-3 * tmrValues2->Interval;
    double sin = std::sin(M_PI/4 * t) + 0.3 * std::sin(12*M_PI * t);
    double cos = std::cos(M_PI/4 * t) + 0.3 * std::cos(12*M_PI * t);

    me1[0]->Value = M0 * ( 1 + sin/2 );
    me1[1]->Value = M1 * ( 1 + cos/2 );
}


//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::chkEnableDynamic_me1Click(TObject *Sender)
{
    me1[0]->EnableDynamic = chkEnableDynamic_me1->Checked;
    me1[1]->EnableDynamic = me1[0]->EnableDynamic;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::chkEnableDynamic_me2Click(TObject *Sender)
{
    for(int i=0; i<3; ++i) if(me2[i]) me2[i]->EnableDynamic = chkEnableDynamic_me2->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::chkAntialiased_me1Click(TObject *Sender)
{
    TCheckBox* sender = dynamic_cast<TCheckBox*>(Sender);
    me1[0]->AntiAliased = sender->Checked;
    me1[1]->AntiAliased = me1[0]->AntiAliased;
    for(int i=0; i<3; ++i) if(me2[i]) me2[i]->AntiAliased = sender->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMainDemo::speTimerInterval_me2Change(TObject *Sender)
{
    tmrRandom->Interval = speTimerInterval_me2->Value;
}

//---------------------------------------------------------------------------

